use anyhow::{Result, anyhow};

fn xor_with_key(input: &[u8], key: &[u8]) -> Result<Vec<u8>> {
    if key.is_empty() {
        return Err(anyhow!("empty key"));
    }
    Ok(input
        .iter()
        .zip(key.iter().cycle())
        .map(|(&a, &b)| a ^ b)
        .collect())
}

fn main() -> Result<()> {
    let plaintexts = r#"
Burning 'em, if you ain't quick and nimble I go crazy when I hear a cymbal
"#;
    let key = b"ICE";
    for plaintext in plaintexts.lines() {
        let plaintext_bytes = plaintext.as_bytes();
        let cipher = xor_with_key(plaintext_bytes, key)?;
        println!("{}", hex::encode(cipher));
    }
    Ok(())
}

